with Interfaces; use Interfaces;

package body CORBA_Repository_Root_Repository_Hash is

   P : constant array (0 .. 4) of Natural :=
     (4, 5, 8, 12, 13);

   T1 : constant array (0 .. 4) of Unsigned_8 :=
     (61, 45, 44, 7, 0);

   T2 : constant array (0 .. 4) of Unsigned_8 :=
     (2, 58, 43, 20, 50);

   G : constant array (0 .. 64) of Unsigned_8 :=
     (12, 0, 0, 9, 0, 0, 19, 0, 0, 0, 0, 0, 0, 4, 0, 0, 24, 5, 0, 4, 15, 0,
      0, 23, 0, 8, 0, 22, 0, 0, 0, 12, 0, 17, 0, 0, 21, 0, 25, 0, 1, 0, 3,
      2, 0, 18, 1, 0, 7, 12, 9, 22, 0, 0, 25, 9, 28, 10, 6, 0, 12, 0, 0, 2,
      0);

   function Hash (S : String) return Natural is
      F : constant Natural := S'First - 1;
      L : constant Natural := S'Length;
      F1, F2 : Natural := 0;
      J : Natural;
   begin
      for K in P'Range loop
         exit when L < P (K);
         J  := Character'Pos (S (P (K) + F));
         F1 := (F1 + Natural (T1 (K)) * J) mod 65;
         F2 := (F2 + Natural (T2 (K)) * J) mod 65;
      end loop;
      return (Natural (G (F1)) + Natural (G (F2))) mod 32;
   end Hash;

end CORBA_Repository_Root_Repository_Hash;
